PROGRAM scph
      ! This program calculates phonons self consistently
      ! as described in the paper: ###############
      ! by Petros Souvatzis, Uppsala Univesity Thu Apr  5 10:30:04 CEST
      ! 2007

      IMPLICIT NONE
      EXTERNAL :: getlatt,readinlj,getposcar,invert,cmatmul,readmemoryfile
      EXTERNAL :: getsymblock,readforces,fourierkraft,ForceToForce,getallfreq
      EXTERNAL :: getfree,KRAFTER,kpointsymgenerate,symmrelations,getfreq
      COMPLEX*16, EXTERNAL :: cdotp
      DOUBLE PRECISION, EXTERNAL :: ZRPPOT,PASPOT,EAMPOT,PINPOT,PAAPOT,gaussdistrib,discretegauss
      DOUBLE PRECISION :: PRIMGITTER(3,3),RECGITTER(3,3),LATTCONST,STATE,dosint,UMEAN(3),UMEAN2,UMEAN2S
      INTEGER :: NUMBATOMS,NTYPEATOM
      DOUBLE PRECISION :: TEMPP
      INTEGER :: SSZ(3),NGAUSSAMPLE
      DOUBLE PRECISION :: MASSA(10)
      CHARACTER(LEN=3) :: POT
      CHARACTER(LEN=8) :: SAMPLING
      INTEGER :: NDISP
      DOUBLE PRECISION :: DISPL(864),DISP(4),AZ(4),KMINIMUZ
      INTEGER :: MAXITTER,MAXITTERR,DSITTER
      DOUBLE PRECISION :: RM,BETAA,X1,X2,B1,B2,B3,B4,C6,C8,C10,EPSS,RCUT,AK(7),RK(7),INTE,OD,ODD,KNORM(3)
      INTEGER :: NATOMTOT,NATOM,GAMMAMEM(3),II1,II2,II3
      DOUBLE PRECISION, ALLOCATABLE :: MASSUB(:),basis(:,:),RS(:,:),QPCOM(:,:),FREEE(:),ITERNALE(:),DOSINTEGRAL(:),U2(:)
      INTEGER :: i,j,l,m,n,n1,n2,n3,n4
      DOUBLE PRECISION :: K(3),TODIR(3,3),F(3),MAXAMP
      LOGICAL, PARAMETER :: DEBUG = .TRUE.
      LOGICAL :: finns,finns2,SKRIV,finns1,SUPERSAFE,SYMETRIZATION
      COMPLEX*16, ALLOCATABLE :: QAMP(:,:),QAMPN(:,:)
      COMPLEX*16, ALLOCATABLE :: WVECTOR(:,:,:),WVECTORS(:,:,:),CMAT(:,:),CMAT1(:,:),CMAT2(:,:),WW(:,:,:),WWW(:,:,:)
      COMPLEX*16, ALLOCATABLE :: CVEC1(:),CVEC2(:),CVEC3(:)
      INTEGER,ALLOCATABLE :: SYMBLOCK(:,:,:,:),NMASS(:)
      DOUBLE PRECISION :: SYMOP(48,3,3),friaenergin,inree,R(3)
      INTEGER :: NSYMREL
      INTEGER, ALLOCATABLE :: DEG(:),FOUM(:,:),NDEG(:),NFOUM(:,:),DEGEN(:,:)
      DOUBLE PRECISION, ALLOCATABLE :: OLDFREQ(:,:),FREQ(:,:),OMEG(:),SYMOPF(:,:,:,:),ALLFREQ(:,:)
      INTEGER :: ITTER,NSYM,antalmod,NSUBB,NSUB
      DOUBLE PRECISION, ALLOCATABLE :: FORCES(:,:)
      COMPLEX*16, ALLOCATABLE :: FFORCE(:,:),UC(:,:),TESTMAT(:,:)
      DOUBLE PRECISION,ALLOCATABLE :: SIGNS(:,:,:),U(:,:)
      REAL :: SLUMP
      LOGICAL,ALLOCATABLE,DIMENSION(:,:) :: WINV,BLANDAD,STABLE
      DOUBLE PRECISION, PARAMETER :: pi = 3.1415926535897932384626433832795028841970d0
      DOUBLE PRECISION, PARAMETER :: mep = 0.0001
      DOUBLE PRECISION :: KB,h,hbarm,hamp,const2
      COMPLEX*16, PARAMETER :: IM = (0.0d0, 1.0d0 )
      
      !Some usefull constants:
      KB = 8.61739/100000.0 ! ( Boltz const [eV/K] )
      h = 4.135669/1000.0 ! (Plancks constant [eV/THz]
      hbarm = 4.135669*16.021773/((pi*2.0d0)**2*1.66054)! (h/(M*Omeg)) ->  angst**2
      hamp = 41.35669 ! h/Omeg -> 10**(-28) eVs**2
      const2 = sqrt(1.602177/1.66054)*100 ! sqrt(eV/(angst**2*au)) --> THz
      !Reading the INPHON-file:
      IF (DEBUG) print*,'##### READING INPHON #####'
      call getlatt(PRIMGITTER,RECGITTER,LATTCONST,NUMBATOMS,NTYPEATOM,TEMPP,SSZ,MASSA)

      !Reading the INPUTFLJ-file:
      IF (DEBUG) print*,'##### READING INPUTFLJ #####'
      call readinlj(POT,NDISP,DISPL,SAMPLING,NGAUSSAMPLE,MAXITTER,DSITTER,SUPERSAFE,MAXAMP,RM,BETAA,X1,X2,B1,B2,B3,B4,C6,C8,C10,EPSS,RCUT,AK,RK,AZ,SYMETRIZATION)
      
      !Reading the POSCAR-file:
      NATOM = NUMBATOMS
      NATOMTOT = SSZ(1)*SSZ(2)*SSZ(3)*NUMBATOMS
      NSUB = SSZ(1)*SSZ(2)*SSZ(3)
      ALLOCATE(MASSUB(NUMBATOMS),basis(NUMBATOMS,3),RS(NATOMTOT,3),NMASS(NTYPEATOM))
      
      IF (DEBUG) print*,'##### READING POSCAR #####'
      call getposcar(NATOMTOT,SSZ,NUMBATOMS,NTYPEATOM,MASSA,PRIMGITTER,RECGITTER,MASSUB,basis,RS,NMASS)
      !--Test of reason behind strange hcp phonon dispersions as compared to
      !--cubic phonons.  4 Nov. 2009
      !PRIMGITTER = TRANSPOSE(PRIMGITTER)
      !RECGITTER = TRANSPOSE(RECGITTER)
      !------------------------------- End of change made 4 Nov. 2009.
      call invert(PRIMGITTER,TODIR)
      MAXITTERR = MAXITTER+1
      ! Here all of the allocations left is going to take place
      antalmod = 3*NUMBATOMS
      NSYMREL = (NUMBATOMS*SSZ(1)*SSZ(2)*SSZ(3))**2
      NSUBB = NSUB+1
      ALLOCATE(QPCOM(NSUB,3),QAMP(NSUB,antalmod),QAMPN(NSUB,antalmod),DEG(NSUB),FOUM(NSUB,NSUB))
      ALLOCATE(NDEG(NSUB),NFOUM(NSUB,NSUB),TESTMAT(antalmod,antalmod))
      ALLOCATE(WVECTOR(NSUB,antalmod,antalmod),WVECTORS(NSUB,antalmod,antalmod),SYMBLOCK(NATOM,NATOM,NSYMREL,4),SYMOPF(NATOM,48,3,3))
      ALLOCATE(FORCES(NATOMTOT,3),FFORCE(NSUB,antalmod),SIGNS(MAXITTERR,NSUB,antalmod),FREEE(MAXITTERR))
      ALLOCATE(CMAT(antalmod,antalmod),OMEG(antalmod),DEGEN(NSUB,antalmod),ITERNALE(MAXITTERR),DOSINTEGRAL(MAXITTERR),U2(MAXITTERR))
      ALLOCATE(CVEC1(antalmod),CVEC2(antalmod),CVEC3(antalmod),WINV(NSUB,antalmod),WW(NSUB,antalmod,antalmod))
      ALLOCATE(WWW(NSUB,antalmod,antalmod),OLDFREQ(NSUB,antalmod),FREQ(NSUB,antalmod),ALLFREQ(NSUB,antalmod))
      ALLOCATE(UC(NSUBB,antalmod),U(NATOMTOT,3),CMAT1(antalmod,antalmod),CMAT2(antalmod,antalmod),BLANDAD(NSUB,antalmod),STABLE(NSUB,antalmod))
      ! Creating the commensurate k-point mesh
      IF (DEBUG) print*,'##### CREATING QPCOM #####'
      
      n = 0
      DO i=0,SSZ(1)-1
       DO j=0,SSZ(2)-1
        DO l=0,SSZ(3)-1
         n=n+1
         K(1) = (i*1.0d0)/(SSZ(1)*1.0d0)
         K(2) = (j*1.0d0)/(SSZ(2)*1.0d0)
         K(3) = (l*1.0d0)/(SSZ(3)*1.0d0)
         QPCOM(n,:) = K
         ENDDO
        ENDDO
       ENDDO
       
       !Creating symmetry information and symmetry matrices for the later
       !symmetrization of the force-constant matrices
       IF (DEBUG) print*,'##### CREATING SYMBLOCK #####'
       call getsymblock(NATOM,NTYPEATOM,SSZ,NSYMREL,SYMBLOCK,SYMOPF)
       
       
       IF ( POT .EQ. 'ABI' ) THEN
               inquire(file='MEMORYFILE',exist=finns)
               IF ( finns ) THEN
                       IF (DEBUG) print*,'##### READING MEMORYFILE #####'
                       SKRIV = .FALSE.
                       call readmemoryfile(OLDFREQ,QAMP,WVECTOR,WVECTORS,ITTER,MAXITTERR,FREEE,ITERNALE,DOSINTEGRAL,U2,NSUB,antalmod,SKRIV,BLANDAD,GAMMAMEM,STABLE)
                       call symmrelations(NSUB,SSZ,FOUM,DEG,NFOUM,NDEG) !creating degenerancy arrays DEG,FOUM
                      
                       IF (DEBUG) print*,'##### READING FORCES #####'
                       call readforces(FORCES,NATOMTOT,NDISP,DISPL,ITTER)
                        
                       IF (DEBUG) print*,'##### CALCULATING F(k) #####'
                       call fourierkraft(FORCES,NATOM,NTYPEATOM,NSUB,NATOMTOT,QPCOM,antalmod,MASSA,SSZ,FFORCE)
                        
                       IF (DEBUG) print*,'##### CALCULATING F(k) --> F(R)  #####'
                       call ForceToForce(FFORCE,NATOM,NTYPEATOM,NSUB,antalmod,ITTER,MASSA,SSZ,OLDFREQ &
                       & ,QAMP,WVECTOR,WVECTORS,SYMBLOCK,SYMOPF,NSYMREL,QPCOM,DEG,FOUM,NDISP,DISPL,BLANDAD,STABLE,SYMETRIZATION)

               ELSE
                       ITTER = 0
                       U2(:) = 0.0d0
                       IF (DEBUG) print*,'##### READING FORCES (ITTER = 0) #####'
                       call readforces(FORCES,NATOMTOT,NDISP,DISPL,ITTER)
                       ! Calculating the free energy of the initial guess
                       call getfree(friaenergin,inree,dosint,UMEAN2)
                       FREEE(ITTER+1) = friaenergin
                       ITERNALE(ITTER+1) = inree
                       DOSINTEGRAL(ITTER+1) = dosint
                       UMEAN2S = UMEAN2
               ENDIF
       ELSE
               ITTER = 0

               IF (DEBUG) print*,'##### CALCULATING FORCES (ITTER = 0) #####'
               1 FORMAT(I1)
               2 FORMAT(I3,X,3(F15.10,2X))
               3 FORMAT(3(F15.10,2X))
               OPEN(300,FILE='FORCES',ACTION='WRITE')
               WRITE(300,FMT=1)NDISP
               DO i=0,NDISP-1
                  DISP(1) = DISPL(1+4*i)
                  DISP(2) = DISPL(2+4*i)
                  DISP(3) = DISPL(3+4*i)
                  DISP(4) = DISPL(4+4*i)
                  call KRAFTER(DISP,RM,BETAA,X1,X2,B1,B2,B3,B4,C6,C8,C10,EPSS,RCUT,SSZ,NATOM,NATOMTOT,ITTER,POT,AK,RK,AZ,FORCES)
                  WRITE(300,FMT=2)INT(DISP(1)),DISP(2),DISP(3),DISP(4)
                  DO j=1,NATOMTOT
                         F = FORCES(j,:)
                         WRITE(300,FMT=3)F
                  ENDDO
               ENDDO
               close(300)
               ! Calculating the free energy of the initial guess
               call getfree(friaenergin,inree,dosint,UMEAN2)
               FREEE(ITTER+1) = friaenergin
               ITERNALE(ITTER+1) = inree
               DOSINTEGRAL(ITTER+1) = dosint
               UMEAN2S = UMEAN2
       ENDIF
        
          IF (DEBUG) print*,'##### ENTERING MAIN LOOP #####'
mainloop: DO WHILE ( ITTER .LE. MAXITTER )

                IF ( ITTER .GT. 0 .AND. POT .NE. 'ABI' ) THEN
                        
                        IF (DEBUG) print*,'##### CALCULATING FORCES (ITTER > 0)#####'
                        call KRAFTER(DISP,RM,BETAA,X1,X2,B1,B2,B3,B4,C6,C8,C10,EPSS,RCUT,SSZ,NATOM,NATOMTOT,ITTER,POT,AK,RK,AZ,FORCES)

                        call fourierkraft(FORCES,NATOM,NTYPEATOM,NSUB,NATOMTOT,QPCOM,antalmod,MASSA,SSZ,FFORCE)
                        !IF (DEBUG) THEN
                        !        DO i=1,NSUB
                        !                print*,'K=',i
                        !                print*,'F(k)='
                        !                print*,FFORCE(i,:)
                        !        ENDDO
                        !ENDIF
                        call ForceToForce(FFORCE,NATOM,NTYPEATOM,NSUB,antalmod,ITTER,MASSA,SSZ,OLDFREQ &
                             & ,QAMP,WVECTOR,WVECTORS,SYMBLOCK,SYMOPF,NSYMREL,QPCOM,DEG,FOUM,NDISP,DISPL,BLANDAD,STABLE,SYMETRIZATION)
                ENDIF
                
                IF ( ITTER .EQ. 0 ) THEN
                        BLANDAD = .FALSE.
                        IF (DEBUG) print*,'##### ENTERING K-point symmetrization part ( ITTER = 0 ) #####'
                        ! checking if the files SYMOP and QPOINTS exsist, if not they
                        ! are calculated

                        inquire(file='QPOINTS',exist=finns)
                        inquire(file='SYMOP',exist=finns1)
                        IF ( .not. finns .OR. .not. finns1 ) THEN
                                print*,'GENERATING QPOINTS AND SYMOP'
                                call kpointsymgenerate
                        ENDIF
                ENDIF
                IF ( ITTER .EQ. 0  ) THEN
                     IF (DEBUG) print*,'##### CALCULATING SYMMETRYCONNECTIONS #####'
                        call symmrelations(NSUB,SSZ,FOUM,DEG,NFOUM,NDEG)
                ENDIF 
                IF ( ITTER .EQ. 0 .OR. POT .EQ. 'ABI' ) THEN
                        ! Here the signs (+/-) are randomly chosen for all
                        ! modes, all k-vectors and all iterations
                        
                        IF (DEBUG) print*,'##### CALCULATING SIGNS #####'
                        DO i=1,MAXITTERR
                           DO j=1,NSUB
                              DO l=1,antalmod
                                call RANDOM_NUMBER(SLUMP)
                                IF ( SLUMP .LT. 0.5 )  THEN
                                        SIGNS(i,j,l) = 1.0d0
                                ELSE
                                        SIGNS(i,j,l) = -1.0d0
                                ENDIF
                                IF ( SAMPLING .EQ. 'GAUSS' ) SIGNS(i,j,l) = SIGNS(i,j,l)*sqrt(2.0d0)*gaussdistrib(0.00010d0,5.0d0)
                                IF ( SAMPLING .NE. 'GAUSS' .AND. NGAUSSAMPLE .GT. 1) SIGNS(i,j,l) = SIGNS(i,j,l)*sqrt(2.0d0)*discretegauss(NGAUSSAMPLE,3.0d0)
                               ENDDO
                            ENDDO
                         ENDDO
                  ENDIF
                  IF ( ITTER .EQ. 0 ) THEN 
                        ! Here the eigen vectors W are calculated and stored in
                        ! the array  WVECTOR
                        87 FORMAT(3(F15.10,X))
                        88 FORMAT(6(F15.10,X))
                        IF (DEBUG) print*,'##### CALCULATING EIGEN VECTORS #####'
                        DO i = 1,NSUB
                                K = QPCOM(i,:)
                                call getfreq(antalmod,K,OMEG,CMAT)
                                WVECTORS(i,:,:) = CMAT
                                IF ( i .EQ. 1 .AND. NATOM .EQ. 1) WVECTORS(i,:,:) = 0.0d0
                                DO j=1,antalmod
                                        IF (OMEG(j) .GE. 0 ) THEN 
                                                OLDFREQ(i,j) = (OMEG(j)*2.0d0*pi/const2)**2
                                                STABLE(i,j) = .TRUE.
                                        ENDIF
                                        IF (OMEG(j) .LT. 0 ) THEN
                                                OLDFREQ(i,j) = -(OMEG(j)*2.0d0*pi/const2)**2
                                                STABLE(i,j) = .FALSE.
                                        ENDIF
                                ENDDO
                                !IF (DEBUG) print*,'EIGENVECTORS K=',i
                                !IF (DEBUG) THEN
                                !        DO j=1,antalmod
                                !                IF ( NATOM .EQ. 1) WRITE(*,FMT=87)DBLE(WVECTORS(i,j,:))
                                !                IF ( NATOM .EQ. 2) WRITE(*,FMT=88)DBLE(WVECTORS(i,j,:))
                                !        ENDDO
                                !        print*,'----------------------------'
                                !        DO j=1,antalmod
                                !                IF ( NATOM .EQ. 1) WRITE(*,FMT=87)AIMAG(WVECTORS(i,j,:))
                                !                IF ( NATOM .EQ. 2) WRITE(*,FMT=88)AIMAG(WVECTORS(i,j,:))
                                !        ENDDO
                                !        print*,'----------------------------'
                                ! ENDIF   
                        ENDDO
                   ENDIF 
                   
                   ! Here we check the orthonormality of the eigenvectors
                   77 FORMAT(3(F15.10,X))
                   78 FORMAT(6(F15.10,X))
                   !IF (DEBUG) THEN
                   !     DO i= 1,NSUB
                   !             CMAT1 = WVECTORS(i,:,:)
                   !             CMAT2 = TRANSPOSE(CONJG(CMAT1))
                   !             call cmatmul(antalmod,CMAT1,CMAT2,TESTMAT)
                   !             print*,'K=',i
                   !             DO j=1,antalmod
                   !                     IF ( NATOM .EQ.1 ) WRITE(*,FMT=77)DBLE(TESTMAT(j,:))
                   !                     IF ( NATOM .EQ.2 ) WRITE(*,FMT=78)DBLE(TESTMAT(j,:))
                   !              ENDDO
                   !                     print*,'-------------------------------------------'
                   !             DO j=1,antalmod
                   !                     IF ( NATOM .EQ.1 )WRITE(*,FMT=77)AIMAG(TESTMAT(j,:))
                   !                     IF ( NATOM .EQ.2 )WRITE(*,FMT=78)AIMAG(TESTMAT(j,:))
                   !             ENDDO
                   !                     print*,'-------------------------------------------'
                   !      ENDDO
                   !ENDIF
                   ! Here the signs of the fourier components q(k,s) of 
                   ! k-vector k are set to be the same as those of k-vector
                   ! k' if OMEGA(k,s) = OMEGA(k',s') and k+k' = K
                   ! (reciprocal vector) and W(k,s)*W(k',s') = 1
                   IF ( ITTER .EQ. 0 .OR. POT .EQ. 'ABI' ) THEN
                        IF (DEBUG) print*,'##### CHECKING k1+k2=K degenerancy  #####'
                         WINV = .TRUE.
                         DEGEN = 1
                         DO i=1,NSUB
                           IF ( NDEG(i) .GT. 0 ) THEN
                                   DO j=1,NDEG(i)
                                       DO l=1,antalmod
                                          DO m=1,antalmod
                                                CVEC1 = WVECTORS(i,:,l) 
                                                CVEC2 = WVECTORS(NFOUM(i,j),:,m)
                                                CVEC1 = CONJG(CVEC1)
                                                IF (ABS(DBLE(cdotp(antalmod,CVEC1,CVEC2)) -1.0d0) .LT. mep ) THEN
                                                        IF ( WINV(i,l) .AND. WINV(NFOUM(i,j),m) ) THEN
                                                                SIGNS(:,i,l) = SIGNS(:,NFOUM(i,j),m)
                                                                DEGEN(i,l) = 2
                                                                DEGEN(NFOUM(i,j),m) = 2
                                                                WINV(i,l) = .FALSE.
                                                                WINV(NFOUM(i,j),m) = .FALSE.
                                                        ENDIF
                                                ENDIF 
                                          ENDDO
                                        ENDDO
                                     ENDDO
                            ENDIF
                          ENDDO
                    ENDIF

                   !Here the signs of the q(k,s) are applied to the eigenvectors 
                   ! WVECTORS*SIGNS --> WVECTOR, AND WVECTOR*exp(ikb) --> WW
                   IF (DEBUG) print*,'##### Applying signs and phase  #####'
                   IF (DEBUG) print*,'Signs for +/-q(k,s):'
                   DO i=1,NSUB
                        DO j=1,antalmod
                                WVECTOR(i,:,j)= (SIGNS(ITTER+1,i,j)/DABS(SIGNS(ITTER+1,i,j)))*WVECTORS(i,:,j)
                                !IF (DEBUG) print*,'(K,s)=',i,j
                                !IF (DEBUG) print*,'SIGN=',SIGNS(ITTER+1,i,j)
                                !IF (DEBUG) print*,WVECTORS(i,:,j)
                        ENDDO
                   ENDDO
                   
                   DO i=1,NSUB
                         K = QPCOM(i,:)
                         K = MATMUL(RECGITTER,K)
                         DO j=1,antalmod
                                DO l=1,NATOM
                                        R = MATMUL(PRIMGITTER,basis(l,:))
                                        !IF (DEBUG .AND. j .EQ. 1 ) THEN
                                        !        IF ( l .EQ. 1 ) print*,'Testing e^(2pi*i*K*R)'
                                        !        IF ( l .EQ. 1 ) print*,'K=',i
                                        !        print*,exp(2.0d0*pi*IM*DOT_PRODUCT(R,K))
                                        !ENDIF
                                        n1 = 1+3*(l-1)
                                        n2 = 2+3*(l-1)
                                        n3 = 3+3*(l-1)
                                        IF ( NATOM .GT. 1 ) THEN
                                                WW(i,n1,j)=WVECTOR(i,n1,j)*exp(2.0d0*pi*IM*DOT_PRODUCT(R,K))*sqrt(MASSUB(l))
                                                WW(i,n2,j)=WVECTOR(i,n2,j)*exp(2.0d0*pi*IM*DOT_PRODUCT(R,K))*sqrt(MASSUB(l))
                                                WW(i,n3,j)=WVECTOR(i,n3,j)*exp(2.0d0*pi*IM*DOT_PRODUCT(R,K))*sqrt(MASSUB(l))
                                        ELSE
                                                WW(i,n1,j)=WVECTOR(i,n1,j)*sqrt(MASSUB(l))
                                                WW(i,n2,j)=WVECTOR(i,n2,j)*sqrt(MASSUB(l))
                                                WW(i,n3,j)=WVECTOR(i,n3,j)*sqrt(MASSUB(l))
                                        ENDIF
                                        WWW(i,n1,j)=(1.0d0/MASSUB(l))*WW(i,n1,j)
                                        WWW(i,n2,j)=(1.0d0/MASSUB(l))*WW(i,n2,j)
                                        WWW(i,n3,j)=(1.0d0/MASSUB(l))*WW(i,n3,j)
                                ENDDO
                         ENDDO
                     ENDDO             
                     
                     !Here the fourier components q(k,s) are calculated:
                     call getallfreq(antalmod,NSUB,QPCOM,ALLFREQ)
                
                     ! Here we calculate the logarithmic moment of the
                     ! phonons with k commensurable with the supercell.
                     ! This frequency will be used instead of OMEGA(k,s) (k .NE. 0 ) 
                     ! whenever OMEGA(k,s) is to close to a point where a
                     ! dispersion branch crosses the OMEGA = 0 -axis.

                     INTE =0.0d0
                     DO i=1,NSUB
                        DO j=1,antalmod
                             INTE = (1.0d0/(1.0d0*NSUB))*log(DABS(ALLFREQ(i,j)))
                        ENDDO
                    ENDDO   
                     
                    OD = exp(1.0d0/3.0d0)*exp(INTE)
                     II3 = 0
                     IF ( ITTER .GT. 0 ) THEN
                        ALLFREQ(1,GAMMAMEM(1)) = 0.0d0
                        ALLFREQ(1,GAMMAMEM(2)) = 0.0d0
                        ALLFREQ(1,GAMMAMEM(3)) = 0.0d0
                     ENDIF
                     IF (DEBUG) print*,'##### CALCULATING q(k,s)  #####'
                     DO i=1,NSUB
                        DO j=1,antalmod
                            OMEG(j) = ALLFREQ(i,j)
                            IF ( DABS(OMEG(j)) .GT. mep ) THEN
                                QAMP(i,j) = DABS(SIGNS(ITTER+1,i,j))*(1.0d0/(DEGEN(i,j)*1.0d0))*sqrt((hbarm/(DABS(OMEG(j))))*&
                                &(0.5+1.0/(exp(h*DABS(OMEG(j))/(KB*TEMPP))-1)))
                            ELSE
                                    QAMP(i,j) = CMPLX(0.0d0,0.0d0)
                            ENDIF
                            ! Here at the first iteration the indexes of the acoustic modes at the gamma point 
                            ! are saved
                            IF ( ITTER .EQ. 0 .AND. i .EQ. 1) THEN
                               !print*,'----------->',II3
                               II1 = 0
                               DO II2=1,antalmod
                                  IF ( DABS(ALLFREQ(i,j)) .LT. DABS(ALLFREQ(i,II2))) II1 = II1+1
                               ENDDO
                                  IF ( II1 .GE. antalmod - 3 ) THEN
                                       II3 = II3 +1
                                       GAMMAMEM(II3) = j
                                       ALLFREQ(i,j) = 0.0d0
                                       QAMP(i,j) = CMPLX(0.0d0,0.0d0)
                                  ENDIF
                            ENDIF
                            ! If the phonon frequency is two small the fourier
                            ! component q(k,s) contribution to the displacements
                            ! will be two big. Therfore, in this case the fourier
                            ! component is set to correspond to a contribution
                            ! equivalent to that if OMEGA(k,s) = OMEGA_DEBYE= OD
                            IF ( MAXAMP .EQ. 0.0d0 ) MAXAMP = 1.0d0
                            IF ( DBLE(QAMP(i,j))*DEG(i)/(sqrt(MASSUB(1)*NSUB)) .GT. MAXAMP .AND. ITTER .LE. DSITTER ) THEN
                                    ! Here a linear debye dispersion is assumed with frequency OD 
                                    ! at the  Brillounzone-bondary and OD*|q|/|qmax| elswhere 
                                    ! qmax || q and qmax is on the Brillouin-zone boundary
                                    ! Change done Mon Mar 16 16:59:25 MDT 2009
                                    K = QPCOM(i,:)
                                    KNORM(1) = 2.0d0
                                    KNORM(2) = 2.0d0
                                    KNORM(3) = 2.0d0
                                    IF ( K(1) .GT. 0.5 ) K(1) = 1-K(1)
                                    IF ( K(2) .GT. 0.5 ) K(2) = 1-K(2)
                                    IF ( K(3) .GT. 0.5 ) K(3) = 1-K(3)
                                    IF ( K(1) .GT. 0.0d0 ) KNORM(1) = 1/K(1)
                                    IF ( K(2) .GT. 0.0d0 ) KNORM(2) = 1/K(2)
                                    IF ( K(3) .GT. 0.0d0 ) KNORM(3) = 1/K(3)
                                    KMINIMUZ = 2.0d0
                                    IF (KNORM(1) .LE. KMINIMUZ ) KMINIMUZ = KNORM(1)
                                    IF (KNORM(2) .LE. KMINIMUZ ) KMINIMUZ = KNORM(2)
                                    IF (KNORM(3) .LE. KMINIMUZ ) KMINIMUZ = KNORM(3)
                                    ODD = OD/(KMINIMUZ*0.5)
                                    QAMP(i,j) = DABS(SIGNS(ITTER+1,i,j))*(1.0d0/(DEGEN(i,j)*1.0d0))*sqrt((hbarm/(DABS(ODD)))*&
                                    &(0.5+1.0/(exp(h*DABS(ODD)/(KB*TEMPP))-1)))
                                    BLANDAD(i,j) = .FALSE.
                                    IF ( SUPERSAFE ) QAMP(i,j) = (0.0d0,0.0d0)
                            ENDIF
                            !IF (DEBUG) print*,QAMP(i,j)
                        ENDDO
                     ENDDO
                     
                     
                     ! Here the atomic displacements U(R) are calculated
                     IF (DEBUG) print*,'##### CALCULATING THE DISPLACEMENTS UC(R)  #####'
                     DO i=1,NSUBB
                        UC(i,:) = CMPLX(0.0d0, 0.0d0)
                        R = MATMUL(PRIMGITTER,RS(i,:))
                        IF ( i .EQ. NSUBB ) THEN
                                R(1) = 1.0d0
                                R(2) = 1.0d0
                                R(3) = 1.0d0
                                R = MATMUL(PRIMGITTER,R)
                        ENDIF
                        DO j=1,NSUB
                             K = QPCOM(j,:)
                             K = MATMUL(RECGITTER,K)
                             DO l=1,antalmod
                                   CVEC1 = WWW(j,:,l)
                                   UC(i,:) = UC(i,:)+(1.0d0/(sqrt(1.0d0*NSUB)))*QAMP(j,l)*0.5d0*( CVEC1*exp(2.0d0*pi*IM*DOT_PRODUCT(K,R))+ &
                                             & CONJG(CVEC1)*exp(-2.0d0*pi*IM*DOT_PRODUCT(K,R)))
                             ENDDO
                        ENDDO
                        !IF (DEBUG) print*,'R=',i
                        !IF (DEBUG) print*,UC(i,:)
                     ENDDO   
                        
                      ! Due to the lineardependence of the different phonon
                      ! modes we here recalculate the mode amplitudes q(k,s) 
                      ! (These are the real amplitudes used ! )
                      IF (DEBUG) print*,'##### RECALCULATING q(k,s):##### '
                      DO i=1,NSUB
                        K = QPCOM(i,:)
                        K = MATMUL(RECGITTER,K)
                        DO l=1,antalmod
                           QAMPN(i,l) = 0.0d0
                           CVEC1 = WW(i,:,l)
                           CVEC1 = CONJG(CVEC1)
                           DO j=1,NSUB
                              R = MATMUL(PRIMGITTER,RS(j,:))
                              QAMPN(i,l) = QAMPN(i,l)+(1.0d0/sqrt(NSUB*1.0d0))*DOT_PRODUCT(CVEC1,UC(j,:))*exp(-2.0d0*pi*IM*DOT_PRODUCT(K,R))
                           ENDDO
                         ENDDO
                       ENDDO 
                       90 FORMAT(5(F15.10,X),A7)
                       !IF (DEBUG) THEN
                       !       DO i=1,NSUB
                       !         print*,'QAMP, QAMPN and OMEGA for K=',i
                       !         DO j=1,antalmod
                       !                 IF (ABS(QAMPN(i,j))/ABS(QAMP(i,j)) .GE. 1.1d0 .OR. ABS(QAMPN(i,j))/ABS(QAMP(i,j)) .LE. 0.9d0  ) THEN
                       !                         WRITE(*,FMT=90)QAMP(i,j),QAMPN(i,j),ALLFREQ(i,j),'***'
                       !                 ELSE
                       !                         WRITE(*,FMT=90)QAMP(i,j),QAMPN(i,j),ALLFREQ(i,j),'OK'
                       !                 ENDIF
                       !         ENDDO
                       !       ENDDO
                       !ENDIF
                      
                      ! Here we mark all QAMP's that fulfill 0.9 < |QAMPN/QAMP| < 1.1
                      ! by setting them to 0.0d0. Don't worry if the degenerancy
                      ! don't take care of this the frequencies of a previous
                      ! itteration will be used in the ForceToForce subroutine !
                      DO i=1,NSUB
                        DO j=1,antalmod
                                IF (ABS(QAMPN(i,j)-QAMP(i,j))/ABS(QAMPN(i,j)) .GE. 1.0d0 .OR. QAMP(i,j) .EQ. (0.0d0,0.0d0) ) THEN
                                        QAMP(i,j) = (0.0d0, 0.0d0 )
                                ELSE
                                        QAMP(i,j) = QAMPN(i,j)
                                ENDIF
                     !---------------------------OPTFIX-------------------------------------------------------------------------------------
                     ! If the fourier-amplitud is less than its standard deviation  would be at T= 0, then the amplitude is perhaps to small 
                     ! to give a force-contribution that is numerically trustwothy and should be thrown away. Let's see what happens.
                     ! This safety routine is only active qt lower temperatures, i.e when T < T_D.
                     !----------------------------------------------------------------------------------------------------------------------
                                IF ( TEMPP .LT. OD*4.13566740d0/(KB*1000.0d0) ) THEN
                                        print*,'------------------------------------------------------'
                                        print*,'Low temperature safety mechanism activated'
                                        print*,'Since T =',TEMPP,'K is less then the Debye-temperature'
                                        print*,'T_D=',OD*4.13566740d0/(KB*1000.0d0),'K'
                                        print*,'------------------------------------------------------'
                                ENDIF
                                IF ( ABS(QAMP(i,j)) .LT. (1.0d0/(DEGEN(i,j)*2.0d0))*sqrt(hbarm/(DABS(OMEG(j)))) .AND. TEMPP .LT. OD*4.13566740d0/(KB*1000.0d0)) THEN
                                        IF ( NGAUSSAMPLE .EQ. 1 .AND. SAMPLING .NE. 'GAUSS' ) THEN
                                                QAMP(i,j) = (0.0d0, 0.0d0 )
                                                print*,'------------------------------------'
                                                print*,'Warning the mode (k,s)=',i,j
                                                print*,'Has a fourier amplitude < ampl(T=0)'
                                                print*,'------------------------------------'
                                        ENDIF
                                ENDIF
                     !-------------------------END OPTFIX -----------------------------
                        ENDDO
                      ENDDO


                     
                     !Here the atomc displacements are converted to real numbers
                     !in direct coordinates
                     IF (DEBUG) print*,'##### CALCULATING U(R)=REAL(UC(R)) (Dir coordinates)  #####'
                     DO j=1,NATOM   
                       DO i=1,NSUB
                           n1 = 1+(j-1)*3
                           n2 = 2+(j-1)*3
                           n3 = 3+(j-1)*3
                           R(1) = DBLE(UC(i,n1))/LATTCONST
                           R(2) = DBLE(UC(i,n2))/LATTCONST
                           R(3) = DBLE(UC(i,n3))/LATTCONST
                           n4 = i+(j-1)*NSUB
                           U(n4,:) = MATMUL(TODIR,R)
                         ENDDO
                     ENDDO

                     ! Here the mean-displacement amplitude <U(R)> is
                     ! calculated:

                     IF (DEBUG) print*,'##### CALCULATING <U(R)> and <U(R)**2> (angstroem, angstroem**2)  #####'
                     UMEAN = 0.0d0
                     UMEAN2 = 0.0d0
                     DO j=1,NATOM
                        DO i=1,NSUB
                          n1 = 1+(j-1)*3
                          n2 = 2+(j-1)*3
                          n3 = 3+(j-1)*3
                          R(1) = DBLE(UC(i,n1))
                          R(2) = DBLE(UC(i,n2))
                          R(3) = DBLE(UC(i,n3))
                          UMEAN = UMEAN + R
                          UMEAN2 = UMEAN2 + DOT_PRODUCT(R,R)
                        ENDDO
                     ENDDO
                     UMEAN = UMEAN/(1.0d0*NSUB)
                     UMEAN2 = UMEAN2/(1.0d0*NSUB)
                          
                    
                    !Here the POSCARTEMP1-file is written, containing the atomic 
                    !positions R+U(R) (In direct coordinates )
                    IF (DEBUG) print*,'##### WRITING POSCARTEMP1-file #######'
                    
                    OPEN(30,FILE='POSCARTEMP1',ACTION='WRITE')
                    WRITE(30,*)'Supercell with temp. displ.'
                    60 FORMAT(3(F20.14,2X))
                    61 FORMAT(F10.7)
                    WRITE(30,FMT=61)LATTCONST
                    WRITE(30,FMT=60)PRIMGITTER(:,1)
                    WRITE(30,FMT=60)PRIMGITTER(:,2)
                    WRITE(30,FMT=60)PRIMGITTER(:,3)
                    WRITE(30,*)NMASS
                    WRITE(30,*)'Direct'
                    DO i=1,NATOMTOT
                        R = RS(i,:)+U(i,:)
                        WRITE(30,FMT=60)R(1),R(2),R(3)
                    ENDDO
                    close(30)
                    
                    IF (DEBUG) print*,'##### WRITING DEBUGGING INFORMATION #######'
                    IF (DEBUG)THEN
                        OPEN(40,FILE='DISPLACEMENTS',ACTION='WRITE')
                        70 FORMAT(3(F20.14,2X))
                        DO i=1,NATOMTOT
                                WRITE(40,FMT=70)U(i,:)
                        ENDDO
                        close(40)
                        print*,'CHECKING PERIODICITY OF DISPLACEMENTS'
                        DO i=1,NATOM
                                print*,'U(0,0,0)-U(1,1,1), for sublattice:',i
                                n1 = 1+(i-1)*3
                                n2 = 2+(i-1)*3
                                n3 = 3+(i-1)*3
                                WRITE(*,70)DBLE(UC(1,n1)-UC(NSUBB,n1)),DBLE(UC(1,n2)-UC(NSUBB,n2)),&
                                & DBLE(UC(1,n3)-UC(NSUBB,n3))
                        ENDDO
                    ENDIF
                       
                   !Calculating the free energy
                   IF ( ITTER .EQ. 0 ) FREEE = 0.0d0
                   IF ( ITTER .EQ. 0 ) ITERNALE = 0.0d0
                   print*,'------------------------------------'
                   print*,'ITERATION #',ITTER
                   print*,'------------------------------------'
                   
                   call getfree(friaenergin,inree,dosint,UMEAN2S)
                   
                   print*,'-----------------------------------'
                   print*,'<U(R)>=',UMEAN
                   print*,'<U(R)**2>=',UMEAN2
                   print*,'<U(R)**2>_dos=',UMEAN2S
                   IF ( UMEAN2 .GE. UMEAN2S) THEN
                           print*,'##### WARNING: <U(R)**2>  >  <U(R)**2>_dos ####'
                   ENDIF
                   print*,'-----------------------------------'
                   ITTER = ITTER +1
                   FREEE(ITTER) = friaenergin
                   ITERNALE(ITTER) = inree
                   DOSINTEGRAL(ITTER) = dosint
                   U2(ITTER) = UMEAN2
                   62 FORMAT(I4,5(F15.10,2X),F18.13)
                   96 FORMAT(A6,A12,A16,A18,A15,A20,A20)
                   IF ( ITTER .EQ. 0 .OR. POT .EQ. 'ABI' ) STATE = 0.0d0
                   
                   IF ( ITTER .GE. 2 ) THEN
                           IF ( POT .EQ. 'ZRP' .AND. ITTER .EQ. 2 ) THEN
                                   STATE =  ZRPPOT(b1,b2,b3,b4,x1,x2,NATOMTOT,NATOM,NSUB,RS,basis,PRIMGITTER,LATTCONST,5,0.000000001 )
                           ENDIF
                           IF ( POT .EQ. 'PAS' .AND. ITTER .EQ. 2 ) THEN 
                                   STATE = PASPOT(RK,AK,BETAA,RM,X1,X2,NATOMTOT,NATOM,NSUB,RS,basis,PRIMGITTER,LATTCONST,5,0.000000001)
                           ENDIF
                           IF ( POT .EQ. 'EAM' .AND. ITTER .EQ. 2 ) THEN
                                   STATE = EAMPOT(b1,b2,b3,b4,x1,x2,RM,NATOMTOT,NATOM,NSUB,RS,basis,PRIMGITTER,LATTCONST,5,0.000000001)
                           ENDIF
                           IF ( POT .EQ. 'PIN' .AND. ITTER .EQ. 2 ) THEN
                                STATE = PINPOT(b1,b2,b3,b4,RK,AK,NATOMTOT,NATOM,NSUB,RS,basis,PRIMGITTER,LATTCONST,5,0.000000001)
                           ENDIF
                           IF ( POT .EQ. 'PAA' .AND. ITTER .EQ. 2 ) THEN
                        STATE = PAAPOT(RK,AK,AZ,BETAA,B1,B2,B3,B4,C6,C8,C10,EPSS,RM,X1,X2,NATOMTOT,NATOM,NSUB,RS,basis,PRIMGITTER,LATTCONST,5,0.000000001)
                           ENDIF
                           OPEN(50,FILE='CONVERGENCE',ACTION='WRITE')
                           WRITE(50,FMT=96)'ITTER','F [ eV ]','E [ eV ]','DF [ eV ]','V [ eV ]','Dos_Integral','<U(R)^2> [ a**2 ]'
                           DO i =2,ITTER
                                WRITE(50,FMT=62)i-1,FREEE(i),ITERNALE(i),DABS(FREEE(i)-FREEE(i-1)),STATE,DOSINTEGRAL(i),U2(i)
                           ENDDO
                           close(50)
                   ENDIF
                   IF ( ITTER .GE. 2 ) THEN
                           OPEN(88,FILE='BLANDAD',ACTION='WRITE')
                           814 FORMAT(1L5,X)
                           815 FORMAT(3(F15.10))
                           DO i=1,NSUB
                                WRITE(88,*)'K=',i
                                WRITE(88,FMT=815)QPCOM(i,:)
                                DO j=1,antalmod
                                    WRITE(88,FMT=814)BLANDAD(i,j)
                                ENDDO
                           ENDDO
                   ENDIF

                   IF ( POT .EQ. 'ABI' ) GOTO 30
           ENDDO mainloop
                                
       30 continue
       IF ( POT .EQ.'ABI' ) THEN
               IF (DEBUG) print*,'##### WRITING MEMORYFILE #######'
               SKRIV = .TRUE.
               call readmemoryfile(OLDFREQ,QAMP,WVECTOR,WVECTORS,ITTER,MAXITTERR,FREEE,ITERNALE,DOSINTEGRAL,U2,NSUB,antalmod,SKRIV,BLANDAD,GAMMAMEM,STABLE)
       ENDIF
END PROGRAM scph       

       
                       
